// controls

import * as Inputs from "npm:@observablehq/inputs";
import random from "npm:random";
import * as d3 from "npm:d3-color";


console.log("Hi there");
console.log(d3);
console.log(d3.rgb(1, 0, 0));

function random_colour() {
	const r = random.float(0, 1) * 255;
	const g = random.float(0, 1) * 255;
	const b = random.float(0, 1) * 255;
	return d3.rgb(r, g, b).formatHex();
}


function random_palette() {

	// monochrome
	// one spot
	// two spot
 	// RGB
 	// CMY
 	// RYB
 	// triad - full saturation
 	// triad - pastel
 	// trial - dusk
 	// random HSV
 	// random RGB
}

class DotControls {
//
	constructor(fg, radius_opts) {	
		this.radius_opts = radius_opts;
		this.fg = Inputs.color({label: "colour", value: fg});
		this.m = Inputs.range([1, 5], {value: 2, step: 1, label:"m"});
		this.n = Inputs.range([1, 5], {value: 2, step: 1, label:"n"});
		this.r = Inputs.range([0, 0.4], {value: 0.2, step: 0.01, label: "radius"});
		this.f = Inputs.select(radius_opts, {label: "gradient", value: radius_opts[0]});
	}

	random_grid() {
		this.m.value = random.choice([1, 2, 3, 4, 5]);	
		this.n.value = random.choice([1, 2, 3, 4, 5]);
		this.r.value = random.float(0, 0.4);
		this.f.value = random.choice(this.radius_opts);
		this.m.dispatchEvent(new Event("input"));
		this.n.dispatchEvent(new Event("input"));
		this.r.dispatchEvent(new Event("input"));
		this.f.dispatchEvent(new Event("input"));
	}

	random_colours() {
		this.fg.value = random_colour();
		this.fg.dispatchEvent(new Event("input"));
	}


}

export { DotControls, random_colour };